(function () {
    "use strict";

    angular.module('core').controller('grupoUsuarioController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'lookupService', 'grupoUsuarioService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, lookupService, grupoUsuarioService) {
        $scope.initializeLayout('Grupos de Usuário');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: { Ativo: null },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    grupoUsuarioService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();

                                    if (action === $scope.popups.add.saveAction.saveAndNew) {
                                        $scope.popups.add.steps.index = 0;
                                        $scope.popups.add.toggle();
                                    }
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: { save: 0, saveAndNew: 1 },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepareNew();
                    }
                    else {
                        $scope.popups.add.steps.index = 0;
                    }
                },
                prepareNew: function () {
                    grupoUsuarioService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                    $timeout(function () { $('[ng-model*="popups.add.data.Nome"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.popups.add.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepareNewMembro: function () {
                    var args = {
                        item: $scope.popups.add.data,
                        usuario: $scope.popups.add.tornarMembro
                    };
                    grupoUsuarioService
                        .prepareNewMembro(args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.add.data = response.Data;

                                    $scope.popups.add.tornarMembro = null;
                                    $timeout(function () { $('[ng-model*="popups.add.tornarMembro"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepare: function () {
                    grupoUsuarioService
                        .prepare($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $timeout(function () { $('[ng-model*="popups.add.data.Nome"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 2,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                },
            },
            edit: {
                ativo: false,
                data: {},
                save: async (manterAberto) => {
                    if ($scope.popups.edit.processando)
                        return;

                    $scope.popups.edit.processando = true;

                    try {
                        const response = await grupoUsuarioService.save($scope.popups.edit.data);

                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                            console.log(response);
                        } else {
                            if (!manterAberto)
                                $scope.historyBack();
                            else
                                $scope.popups.edit.data = response.Data;
                        }
                    } catch (error) {
                        $scope.tools.toastr.error($scope.message.default.serverNotFound);
                        console.error(error);
                    } finally {
                        $scope.$digest();
                    }

                    $scope.popups.edit.processando = false;
                },
                toggle: function (id) {
                    $scope.popups.edit.ativo = !$scope.popups.edit.ativo;
                    if ($scope.popups.edit.ativo && id) {
                        $scope.popups.edit.get(id);
                    }
                },
                get: async (id) => {
                    $scope.popups.edit.processando = true;

                    try {
                        var response = await grupoUsuarioService.get({ id: id });

                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                            $scope.popups.edit.ativo = false;
                        } else {
                            $scope.popups.edit.data = response.Data;
                            $scope.popups.edit.ativo = true;
                        }
                    } catch (e) {
                        $scope.tools.toastr.error($scope.message.default.serverNotFound);
                        console.error(e);
                    }

                    $scope.popups.edit.processando = false;
                },
                delete: async (id) => {
                    if ($scope.popups.edit.processando)
                        return;

                    $scope.popups.edit.processando = true;

                    try {
                        const response = await grupoUsuarioService.delete(id ? id : $scope.popups.edit.data.ID);
                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                            console.error(response);
                        } else {
                            if ($scope.popups.edit.ativo)
                                $scope.historyBack();
                            else
                                $scope.refresh();
                        }

                    } catch (e) {
                        $scope.tools.toastr.error($scope.message.default.serverNotFound);
                        console.error(e);
                    }

                    $scope.popups.edit.processando = false;

                },
                prepare: async () => {
                    try {

                        const response = await grupoUsuarioService.prepare($scope.popups.edit.data);

                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                            console.error(response);
                        } else {
                            $scope.popups.edit.data = response.Data;
                            $scope.popups.edit.ativo = true;
                        }

                    } catch (e) {
                        $scope.tools.toastr.error($scope.message.default.serverNotFound);
                        console.error(e);
                    }
                },
                prepareNewMembro: async () => {
                    try {
                        var args = {
                            item: $scope.popups.edit.data,
                            usuario: $scope.popups.edit.tornarMembro
                        };

                        const response = await grupoUsuarioService.prepareNewMembro(args);

                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                            console.error(response);
                        } else {
                            $scope.popups.edit.data = response.Data;
                            $scope.popups.edit.tornarMembro = null;
                            $timeout(() => $('[ng-model*="popups.edit.tornarMembro"]').focus());
                        }

                    } catch (e) {
                        $scope.tools.toastr.error($scope.message.default.serverNotFound);
                        console.error(e);
                    }
                },
                prepareNewPermissao: async () => {
                    try {
                        var args = {
                            item: $scope.popups.edit.data,
                            permissao: {
                                GrupoUsuario: {
                                    ID: $scope.popups.edit.data.ID,
                                    Codigo: $scope.popups.edit.data.Codigo,
                                    Nome: $scope.popups.edit.data.Nome
                                },
                                Classe: $scope.popups.edit.newPermissao
                            }
                        };

                        const response = await grupoUsuarioService.prepareNewPermissao(args);

                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                            console.error(response);
                        } else {
                            $scope.popups.edit.data = response.Data;
                            $scope.popups.edit.newPermissao = null;
                            $timeout(() => $('[ng-model*="popups.edit.newPermissao"]').focus());
                        }

                    } catch (e) {
                        $scope.tools.toastr.error($scope.message.default.serverNotFound);
                        console.error(e);
                    }
                },
            },
        };
        $scope.auxiliar = {
            usuario: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllUsuario({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            centroCusto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCentroCusto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            classe: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllClasse({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = async () => {
            await $scope.clearFilter();

            const _filtro = $scope.localStorage.getItem('state.filtro.args');
            if (_filtro) {
                await angular.copy(_filtro, $scope.state.filtro.args);
            }

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);

            $scope.refresh();
        };

        $scope.beforeRefresh = async () => {
            await $scope.convertFilter();
        };
        $scope.afterRefresh = async () => {
            /* trata mudanças no filtro */
            $scope.state.filtro.original.sortExpression = $scope.state.filtro.args.sortExpression;
            $scope.state.filtro.original.skip = $scope.state.filtro.args.skip;
            $scope.state.filtro.original.take = $scope.state.filtro.args.take;

            $scope.state.filtro.hasChanges = (angular.toJson($scope.state.filtro.original) !== angular.toJson($scope.state.filtro.args));

            /* armazena na localstorage para quando inicializar a página */
            $scope.localStorage.setItem('state.filtro.args', $scope.state.filtro.args);
        };
        $scope.refresh = async () => {
            try {
                await $scope.beforeRefresh();
                $scope.state.filtro.ativo = false;
                await $scope.innerRefresh();
                await $scope.afterRefresh();
            }
            catch (error) {
                console.error(error);
                $scope.clearFilter();
            } finally {
                $scope.$digest();
            }
        };
        $scope.clear = async () => {
            await $scope.clearFilter();
            $scope.refresh();
        };

        $scope.toggleFilter = async () => {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        $scope.convertFilter = async () => {
            /* prepara o filtro. Ex: in list de status */
        };
        $scope.clearFilter = async () => {
            $scope.state.filtro = {
                args: {
                    chaves: '',
                    filtro: null,
                    filtroDe: {},
                    filtroAte: {},
                    sortExpression: '[Nome]',
                    skip: 0,
                    take: 20
                },
                original: {},
                hasChanges: false
            };

            await $scope.convertFilter();
            await angular.copy($scope.state.filtro.args, $scope.state.filtro.original);
        };

        $scope.innerRefresh = async () => {
            await $scope.getAll();
            await $scope.count();
        };
        $scope.getAll = async () => {
            try {
                $scope.state.filtro.args.skip = 0;
                $scope.state.carregando = true;
                $scope.state.vazio = false;

                let response = await grupoUsuarioService.getAll($scope.state.filtro.args)
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    angular.copy(angular.fromJson(response.Data), $scope.state.data);
                }
                $scope.state.vazio = ($scope.state.data == 0);
            }
            catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
            }
            finally {
                $scope.state.carregando = false;
                $scope.$apply();
            }
        };
        $scope.count = async () => {
            try {
                let response = await grupoUsuarioService.count($scope.state.filtro.args)
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.count = response.Data;
                }
            } catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
            } finally {
                $scope.$apply();
            }
        };
        $scope.getMore = async () => {
            if (!$scope.state.carregandoMais && !$scope.state.carregando && !$scope.state.completo && !($scope.state.data == 0)) {
                try {
                    $scope.state.carregandoMais = true;
                    $scope.state.filtro.args.skip += $scope.state.filtro.args.take;

                    let response = await grupoUsuarioService.getAll($scope.state.filtro.args);
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                    }
                } catch (error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                } finally {
                    $scope.state.carregandoMais = false;
                    $scope.$apply();
                }
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();